commit f1df4bd9beabb55ed3364dc3e031b58f40c9d818
Author: freddy77 <freddy77>
Date:   Mon May 26 13:56:48 2008 +0000

    fix some memory problems

diff --git a/ChangeLog b/ChangeLog
index 647f15f..4e5919a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+Wed May  7 15:56:10 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	(monstly from Coverity reports)
+	* include/tdsbytes.h: remove warning
+	* src/apps/tsql.c src/dblib/bcp.c src/dblib/dblib.c:
+	- remove some leaks
+	* src/tds/mem.c: avoid deference of null pointer
+
 Wed May 21 23:51:21 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* src/odbc/unittests/common.c
 	* vms/config_h.vms vms/descrip_mms.template
@@ -292,4 +299,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2522 2008/05/22 03:53:16 jklowden Exp $
+$Id: ChangeLog,v 1.2523 2008/05/26 13:56:48 freddy77 Exp $
diff --git a/include/tdsbytes.h b/include/tdsbytes.h
index 8529651..baf4a79 100644
--- a/include/tdsbytes.h
+++ b/include/tdsbytes.h
@@ -20,7 +20,7 @@
 #ifndef _tdsbytes_h_
 #define _tdsbytes_h_
 
-/* $Id: tdsbytes.h,v 1.2 2005/08/10 12:06:03 freddy77 Exp $ */
+/* $Id: tdsbytes.h,v 1.3 2008/05/26 13:56:49 freddy77 Exp $ */
 
 #ifndef _tds_h_
 #error tds.h must be included before tdsbytes.h
@@ -61,9 +61,9 @@
 #define TDS_GET_A2BE(ptr) TDS_GET_UA2BE(ptr)
 
 #define TDS_PUT_UA2LE(ptr,val) do {\
- ((TDS_UCHAR*)(ptr))[1] = (val)>>8; ((TDS_UCHAR*)(ptr))[0] = (val); } while(0)
+ ((TDS_UCHAR*)(ptr))[1] = (TDS_UCHAR)((val)>>8); ((TDS_UCHAR*)(ptr))[0] = (TDS_UCHAR)(val); } while(0)
 #define TDS_PUT_UA2BE(ptr,val) do {\
- ((TDS_UCHAR*)(ptr))[0] = (val)>>8; ((TDS_UCHAR*)(ptr))[1] = (val); } while(0)
+ ((TDS_UCHAR*)(ptr))[0] = (TDS_UCHAR)((val)>>8); ((TDS_UCHAR*)(ptr))[1] = (TDS_UCHAR)(val); } while(0)
 #define TDS_PUT_A2LE(ptr,val) TDS_PUT_UA2LE(ptr,val)
 #define TDS_PUT_A2BE(ptr,val) TDS_PUT_UA2BE(ptr,val)
 
@@ -78,11 +78,11 @@
 #define TDS_GET_A4BE(ptr) TDS_GET_UA4BE(ptr)
 
 #define TDS_PUT_UA4LE(ptr,val) do {\
- ((TDS_UCHAR*)(ptr))[3] = (val)>>24; ((TDS_UCHAR*)(ptr))[2] = (val)>>16;\
- ((TDS_UCHAR*)(ptr))[1] = (val)>>8; ((TDS_UCHAR*)(ptr))[0] = (val); } while(0)
+ ((TDS_UCHAR*)(ptr))[3] = (TDS_UCHAR)((val)>>24); ((TDS_UCHAR*)(ptr))[2] = (TDS_UCHAR)((val)>>16);\
+ ((TDS_UCHAR*)(ptr))[1] = (TDS_UCHAR)((val)>>8); ((TDS_UCHAR*)(ptr))[0] = (TDS_UCHAR)(val); } while(0)
 #define TDS_PUT_UA4BE(ptr,val) do {\
- ((TDS_UCHAR*)(ptr))[0] = (val)>>24; ((TDS_UCHAR*)(ptr))[1] = (val)>>16;\
- ((TDS_UCHAR*)(ptr))[2] = (val)>>8; ((TDS_UCHAR*)(ptr))[3] = (val); } while(0)
+ ((TDS_UCHAR*)(ptr))[0] = (TDS_UCHAR)((val)>>24); ((TDS_UCHAR*)(ptr))[1] = (TDS_UCHAR)((val)>>16);\
+ ((TDS_UCHAR*)(ptr))[2] = (TDS_UCHAR)((val)>>8); ((TDS_UCHAR*)(ptr))[3] = (TDS_UCHAR)(val); } while(0)
 #define TDS_PUT_A4LE(ptr,val) TDS_PUT_UA4LE(ptr,val)
 #define TDS_PUT_A4BE(ptr,val) TDS_PUT_UA4BE(ptr,val)
 
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index 17268ef..a298b79 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -85,7 +85,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.113 2008/01/11 12:43:39 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.114 2008/05/26 13:56:49 freddy77 Exp $");
 
 enum
 {
@@ -524,6 +524,7 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 	}
 
 	/* free up all the memory */
+	free(confile);
 	free(hostname);
 	free(username);
 	free(password);
@@ -572,6 +573,7 @@ slurp_input_file(char *fname, char **mybuf, int *bufsz, size_t *buflen, int *lin
 		tsql_add_history(s);
 		(*line)++;
 	}
+	fclose(fp);
 }
 
 extern const char STD_DATETIME_FMT[];
@@ -709,7 +711,7 @@ main(int argc, char **argv)
 		 *  The rest of the line may include options that apply to the batch, 
 		 *  and perhaps whitespace.  
 		 */
-		if (0 == strncasecmp(s, "go", 2) && (strlen(s) == 2 || isspace(s[2]))) {
+		if (0 == strncasecmp(s, "go", 2) && (strlen(s) == 2 || TDS_ISSPACE(s[2]))) {
 			char *go_line = strdup(s);
 			assert(go_line);
 			line = 0;
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index d238783..2810fcb 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -71,7 +71,7 @@ typedef struct _pbcb
 }
 TDS_PBCB;
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.171 2008/01/08 15:38:31 jklowden Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.172 2008/05/26 13:56:49 freddy77 Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -799,11 +799,13 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 
 	if (dbproc->bcpinfo->direction == DB_QUERYOUT ) {
 		if (tds_submit_query(tds, dbproc->bcpinfo->tablename) == TDS_FAIL) {
+			fclose(hostfile);
 			return FAIL;
 		}
 	} else {
 		/* TODO quote if needed */
 		if (tds_submit_queryf(tds, "select * from %s", dbproc->bcpinfo->tablename) == TDS_FAIL) {
+			fclose(hostfile);
 			return FAIL;
 		}
 	}
@@ -1061,6 +1063,7 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 					break;
 				}
 				if( plen != 0 && written != 1 ) {
+					fclose(hostfile);
 					dbperror(dbproc, SYBEBCWE, errno);
 					return FAIL;
 				}
@@ -1073,6 +1076,7 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 				if (buflen > 0) {
 					written = fwrite(hostcol->bcp_column_data->data, buflen, 1, hostfile);
 					if (written < 1) {
+						fclose(hostfile);
 						dbperror(dbproc, SYBEBCWE, errno);
 						return FAIL;
 					}
@@ -1082,6 +1086,7 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 				if (hostcol->terminator && hostcol->term_len > 0) {
 					written = fwrite(hostcol->terminator, hostcol->term_len, 1, hostfile);
 					if (written < 1) {
+						fclose(hostfile);
 						dbperror(dbproc, SYBEBCWE, errno);
 						return FAIL;
 					}
@@ -1094,6 +1099,7 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 		dbperror(dbproc, SYBEBCUC, errno);
 		return (FAIL);
 	}
+	hostfile = NULL;
 
 	if (dbproc->hostfileinfo->firstrow > 0 && row_of_query < dbproc->hostfileinfo->firstrow) {
 		/* 
@@ -1896,8 +1902,10 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 		return FAIL;
 	}
 
-	if (_bcp_start_copy_in(dbproc) == FAIL)
+	if (_bcp_start_copy_in(dbproc) == FAIL) {
+		fclose(hostfile);
 		return FAIL;
+	}
 
 	tds->out_flag = TDS_BULK;
 	tds_set_state(tds, TDS_QUERYING);
@@ -1922,6 +1930,7 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 
 			if (errfile == NULL && dbproc->hostfileinfo->errorfile) {
 				if (!(errfile = fopen(dbproc->hostfileinfo->errorfile, "w"))) {
+					fclose(hostfile);
 					dbperror(dbproc, SYBEBUOE, 0);
 					return FAIL;
 				}
@@ -2003,6 +2012,7 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 						if (tds_process_simple_query(tds) != TDS_SUCCEED) {
 							if (errfile)
 								fclose(errfile);
+							fclose(hostfile);
 							return FAIL;
 						}
 							
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index 4056b75..0d40af7 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.323 2008/04/30 14:09:53 jklowden Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.324 2008/05/26 13:56:49 freddy77 Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -3321,8 +3321,10 @@ dbprrow(DBPROCESS * dbproc)
 			computeid = status;
 
 			for (i = 0;; ++i) {
-				if (i >= tds->num_comp_info)
+				if (i >= tds->num_comp_info) {
+					free(col_printlens);
 					return FAIL;
+				}
 				resinfo = tds->comp_info[i];
 				if (resinfo->computeid == computeid)
 					break;
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 66a5a40..35953b2 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -47,7 +47,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.175 2007/12/31 10:06:50 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.176 2008/05/26 13:56:50 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -1040,6 +1040,9 @@ tds_free_locale(TDSLOCALE * locale)
 void
 tds_free_connection(TDSCONNECTION * connection)
 {
+	if (!connection)
+		return;
+
 	tds_dstr_free(&connection->server_name);
 	tds_dstr_free(&connection->client_host_name);
 	tds_dstr_free(&connection->server_host_name);

